#!usr/bin/env python

#################  AutoMITAur.v1.0: A tool for de novo detection  of MITE ##################
#
# Main objective: de novo detection of MITE in sequenced genome
#
# Scientific contributors:  Aurelie Hua-Van
#
#
# Copyright 2013 Aurelie Hua-Van, ahuavan@legs.cnrs-gif.fr
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
## SCIENTISTS: please be aware that the fact that this program is released
## as Free Software does not excuse you from scientific propriety, which
## obligates you to give appropriate credit! If you write a scientific paper
## describing research that made substantive use of this program, it is your
## obligation as a scientist to (a) mention the fashion in which this software
## was used, including the version number, with a citation to the literature,
## in the Methods section, to allow replication; and/or (b) mention this
## software in the Acknowledgements section.
#
#############################################################################

from Bio.Alphabet import IUPAC
from Bio.Seq import Seq
import re,os,sys,string,shutil
import glob
liste=[]
tmplist=[]

'''
This program analyses a list of untangled Class II 
transposable elements TIRs coordinates 
and filter for non overlapping, non redundant hits
'''
def noanalyse(tmplist):
    dicolength={}
    for s in tmplist:
        dicolength[s]=s[4]-s[1]
    for cle, valeur in dicolength.items():
        if valeur == max(dicolength.values()): return cle

############# OVERLAPPING HIT ANALYSIS###################### 					
def templistanalyse(tmplist):
        
    listanalyse=tmplist
    tmplist=[]
    chosenhit=[]
    # ITR max and min
    minitr5=min([s[1] for s in listanalyse])
    maxitr5=max([s[2]+1 for s in listanalyse])
    minitr3=min([s[4] for s in listanalyse])
    maxitr3=max([s[3]+1 for s in listanalyse])
    maxnbmatch=max([int(s[5]) for s in listanalyse])
    nom=listanalyse[0][0]
    itr5=[]
    itr3=[]
    dicolength={}   
    print
    print 'nb of hits in block', len(listanalyse), minitr5,maxitr3
    #print listanalyse
    
    if len(listanalyse)==1:
    # non overlapping    
        chosenhit=listanalyse

    # non overlapping TIRs
    elif maxitr5<minitr3: 
    # overlapping element with distinct itr : keep the longest
    # 1 - subTIRsequence     2- nested element
    # <==-o-==>              <==-------ooooooooo-------==>  
    #  <==o==>                      <==ooooooooo==>  
        chosenhit.append((nom, minitr5,maxitr5,maxitr3,minitr3, str(maxnbmatch),str(maxitr3-minitr5), 'sat'))
        
    # overlapping TIRs: 
    else:
    #tandem       
    # <===---===>
    # <===---===>-----------===>
    #        ===>----<===
    #                <===---===>
    #                       ===>---<==
        # define the longest TIRs
        for hit in listanalyse:
            itr5.extend(range(hit[1],hit[2]+1))
            itr3.extend(range(hit[4],hit[3]+1))
            dicolength[hit]=hit[4]-hit[1] +1#element length
        s5=set(itr5)
        s3=set(itr3)
        # intervening and nested
        # <===o------------ -------------ooo===>
        #      <===-------- ---------===>
        if len(s5)<maxitr5-minitr5 or len(s3)<maxitr3-minitr3:
            print len(itr5),maxitr5-minitr5,minitr5,len(itr3),maxitr3-minitr3,maxitr3, ' c"est le bordel'
            jeu1=[]
            jeu2=[]
            jeu1.append(listanalyse[0])
            if listanalyse[0][0]<jeu1[-1][3]:jeu1.append(listanalyse.pop(0))
            else: jeu2.append(listanalyse.pop(0))
            if len(listanalyse) !=0:
                if listanalyse[0][1]>jeu1[-1][3]:jeu1.append(listanalyse.pop(0))
                elif listanalyse[0][1]<jeu2[-1][3]:pass
                else:jeu1.append(listanalyse.pop(0))
            chosenhit.extend(jeu1)
            #print 'jeu1'

        # overlap between 5'TIR and 3'TIR
        elif len(list(s5.intersection(s3))) != 0:
            for cle, valeur in dicolength.items():
                if valeur == max(dicolength.values()): long=cle                
                if valeur == min(dicolength.values()): court=cle 
            # remove the shortest and the longest
            listanalyse.remove(court)
            listanalyse.remove(long)
            chosenhit=listanalyse
        # nested 
        elif len(list(s5.intersection(s3))) == 0:
            chosenhit.append(court)
            chosenhit.append(long)
            
    tmplist=[]
    listanalyse=[]
    return chosenhit
    
