#!usr/bin/env python

#################  AutoMITAur.v1.0: A tool for de novo detection  of MITE ##################
#
# Main objective: de novo detection of MITE in sequenced genome
#
# Scientific contributors:  Aurelie Hua-Van
#
#
# Copyright 2013 Aurelie Hua-Van, ahuavan@legs.cnrs-gif.fr
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
## SCIENTISTS: please be aware that the fact that this program is released
## as Free Software does not excuse you from scientific propriety, which
## obligates you to give appropriate credit! If you write a scientific paper
## describing research that made substantive use of this program, it is your
## obligation as a scientist to (a) mention the fashion in which this software
## was used, including the version number, with a citation to the literature,
## in the Methods section, to allow replication; and/or (b) mention this
## software in the Acknowledgements section.
#
#############################################################################


import re,os,sys
dico_lim={} #limite de l'homologie (tuple)
dico_sens={}  # position moyenne de l'homologie
dico_query={} # query
contig={}
dico={} # dico nom de sequence
list=[]
"""
TAB formatted BLAST results are analysed for data extraction:
Accession number, direction and position of homologies
Close hits are grouped together 
Output file with hit positions
"""

def ask():
    input=raw_input('Please provide a BLAST result file (tab format)? ')
    gap=raw_input('Minimum gap between hits for considering them as two independant copies [1000]? ')
    if gap=='':gap='1000'
    db=raw_input('Which geneome database did you use ?\n[GB] = 0\nFo = 1\ngenome = 3\n')
    if db=='':db='0'
    count(input, gap, db)
    
def count(input, gap, db):
################################################################################
#####################           A- Counting copies       #######################
################################################################################
    print '\t>>> Counting copies...'
    dico_lim.clear()
    dico_sens.clear() 
    dico.clear()
    
    line=open(input).readlines()

    log=open(input+'.log','w')
    del list[:]
    reass=0 # reassociated cases :'
    new=0
    deuz=1
    gonext=0
    # for each hsp
    for i,x in enumerate(line):
        if x[0]=='#': del line[i]
        else:
            if '|' in x.split('\t')[1]:
                y=x.split('\t')[1].split('|')[1]
                sp=x.split('\t')[1].split('|')[3]
            else: 
                y=x.split('\t')[1] # contig name
                sp=''                
            contig[y]=(y,sp) #contig name and species
        
        # Caracteristiques: sens, moyenne et limite
        # sequence orientation (s.start et s.end)
            if int(x.split('\t')[8])>int(x.split('\t')[9]):        z=y+'-'
            else:                                                  z=y+'+'    
        # middle position of the hit
            moy=(int(x.split('\t')[8])+int(x.split('\t')[9]))/2.
        # tuple with hit limits
            tup=int(x.split('\t')[8]),int(x.split('\t')[9])
        # pour le log...
            list.append((i,z,int(x.split('\t')[9]),int(x.split('\t')[8]),abs(int(x.split('\t')[9])-int(x.split('\t')[8]))))
    
        #############         if orientation already met       #########################
            d=0
            if dico_sens.has_key(z): # contig+ or contig -
            # test for each copy already found in this orientation, on this contig, starting with 0
                while dico_sens.has_key(z+str(d)):
                # middle of the copy, and middle of the new hsp
                    old=dico_sens[z+str(d)]
                    oldlimit = dico_lim[z+str(d)]
                    oldquery = dico_query[z+str(d)]

                # if middles of hits less than gap limit, modif of the dict (reassociation case)
                    if abs(moy-old)<int(gap) and moy*((oldlimit[1]+oldlimit[0])/2.) >0 :
                        minlimit=min(oldlimit+tup) # new limit
                        maxlimit=max(oldlimit+tup) # new limit
                        dico_lim[z+str(d)]=(minlimit,maxlimit) # dico limits
                        dico_sens[z+str(d)]=(minlimit+maxlimit)/2 # dico middle
                        reass=reass+1
                        #if dico_query[z+str(d)]!=x.split('\t')[0]: print "oops"
                        break
                 #  if position of ends of hits less than gap, modif of the dict (reassociation case)
                    elif (abs(max(tup)-min(oldlimit))<int(gap) or abs(max(oldlimit)-min(tup))<int(gap)) and moy*((oldlimit[1]+oldlimit[0])/2.) >0 :
                        minlimit=min(oldlimit+tup)
                        maxlimit=max(oldlimit+tup)
                        dico_lim[z+str(d)]=(minlimit,maxlimit)
                        dico_sens[z+str(d)]=(minlimit+maxlimit)/2
                        reass=reass+1
                        #if dico_query[z+str(d)]!=x.split('\t')[0]: print "oops"
                        break
                #si copie differente, mise en dico
                    else:
                        d=d+1
                        if dico_sens.has_key(z+str(d)):
                            gonext+=1
                            pass
                        else : 
                            dico_sens[z+str(d)]=moy
                            dico_lim[z+str(d)]=tup
                            dico_query[z+str(d)]=x.split('\t')[0]
                            deuz+=1
                            break
                      
    ############### si first time in this orientation  ###################
            else :  
                n=0
                dico_sens[z+str(n)]=(int(x.split('\t')[8])+int(x.split('\t')[9]))/2
                dico_sens[z]=dico_sens[z+str(n)] #cretion dico[contig+]=dico[contig+0]
                dico_lim[z+str(n)]=int(x.split('\t')[8]),int(x.split('\t')[9])
                dico_query[z+str(n)]=x.split('\t')[0]
                new+=1
#     print'reassociated cases :', reass
#     print 'new cases :', new
#     print 'deuz cases', deuz
#     print 'gonext cases', gonext
#     print 'total', len(dico_sens)
    for a in list: log.write(str(a)+'\n')
    

    print '\tThere is',len(dico_lim), "different copies"
    flank='300'
    mini='200'
    if __name__=="__main__": write(input,db,flank,mini)
    limite=write(input,db,flank,mini)
    return input, dico_lim,limite

################################################################################
#########################    output file (.pba)
################################################################################

def write(input,db,limite, size):
    pba=open(input+'.pba','w')
    pba2=open(input+'.pba2','w')
    
    for z in dico_lim:
        lenhit=str(max(dico_lim[z])-min(dico_lim[z])) #hit length
        if int(lenhit)<int(size):pass

        else:
            a=min(dico_lim[z])-int(limite)
            b=max(dico_lim[z])+int(limite)
            if a<0:a=0
            if '+' in z:
                y=z.split('+')[0]+'\t'+z.split('+')[0]+'p'+z.split('+')[1]
                pba2.write(y+'\t'+str(a)+'\t'+str(b)+'\t'+lenhit+'\t'+dico_query[z]+'\n')
                pba.write(y+'\t'+str(min(dico_lim[z]))+'\t'+str(max(dico_lim[z]))+'\t'+lenhit+'\t'+dico_query[z]+'\n')
            elif '-' in z:
                y=z.split('-')[0]+'\t'+z.split('-')[0]+'m'+z.split('-')[1]
                pba2.write(y+'\t'+str(b)+'\t'+str(a)+'\t'+lenhit+'\t'+dico_query[z]+'\n')
                pba.write(y+'\t'+str(max(dico_lim[z]))+'\t'+str(min(dico_lim[z]))+'\t'+lenhit+'\t'+dico_query[z]+'\n')

    pba.close()
    pba2.close()
    return limite

    
if __name__ == '__main__' : 
    if len(sys.argv)==4:count(sys.argv[1],sys.argv[2],sys.argv[3])
    else: ask()
else: 
    pass