#!usr/bin/env python

#################  AutoMITAur.v1.0: A tool for de novo detection  of MITE ##################
#
# Main objective: de novo detection of MITE in sequenced genome
#
# Scientific contributors:  Aurelie Hua-Van
#
#
# Copyright 2013 Aurelie Hua-Van, ahuavan@legs.cnrs-gif.fr
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
## SCIENTISTS: please be aware that the fact that this program is released
## as Free Software does not excuse you from scientific propriety, which
## obligates you to give appropriate credit! If you write a scientific paper
## describing research that made substantive use of this program, it is your
## obligation as a scientist to (a) mention the fashion in which this software
## was used, including the version number, with a citation to the literature,
## in the Methods section, to allow replication; and/or (b) mention this
## software in the Acknowledgements section.
#
#############################################################################
import sys, re,os
from Bio.Alphabet import IUPAC
from Bio.Seq import Seq
from Bio import SeqIO
from Bio.SeqRecord import SeqRecord

'''
Take fasta file, and replace pattern in sequence name
'''

def changename(file, newpattern,add):
    newlist=[]
    for sequence in SeqIO.parse(file,'fasta'):
        name=sequence.description
        newname=re.search('(?:%s)'%newpattern,name)
        try:
            newname.group(0)
            newseq=SeqRecord(sequence.seq,id=add+newname.group(0),description='')
            newlist.append(newseq)        #print newname.group(0)
        except:
            print name, "does not match and won't be kept"

        
    SeqIO.write(newlist,file+'N','fasta')

if __name__ == '__main__' : 
    with open(sys.argv[1]) as myfile:
        head=[myfile.next() for x in xrange(1)]
    print head[0]
    newpattern=raw_input('pattern to keep (re) ? ')
    add=raw_input('item to add ? ')
    if newpattern=='': print "clean names"
    #print  newpattern
    else: changename(sys.argv[1],newpattern,add)
    