#!usr/bin/env python

#################  AutoMITAur.v1.0: A tool for de novo detection  of MITE ##################
#
# Main objective: de novo detection of MITE in sequenced genome
#
# Scientific contributors:  Aurelie Hua-Van
#
#
# Copyright 2013 Aurelie Hua-Van, ahuavan@legs.cnrs-gif.fr
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
## SCIENTISTS: please be aware that the fact that this program is released
## as Free Software does not excuse you from scientific propriety, which
## obligates you to give appropriate credit! If you write a scientific paper
## describing research that made substantive use of this program, it is your
## obligation as a scientist to (a) mention the fashion in which this software
## was used, including the version number, with a citation to the literature,
## in the Methods section, to allow replication; and/or (b) mention this
## software in the Acknowledgements section.
#
#############################################################################
import sys, os
from glob import iglob
import automitaur
from optparse import OptionParser





def de(directory):
    try:
        os.mkdir(directory+'/Comp')
    except: pass
    Compfile=open(directory+'/Comp/CompCons.fas','w')
    for i in iglob(directory+'/*.dir/*/Cons/Clust.Cons.fas'):#Cons/Clust.Cons.fas'
        file=open(i).read()
        ClustNb=file.count('>')
        Name=i.split(directory+'/')[1].split('.')[0]
        b=3
        shortName=''
        for item in Name.split('_'):
            shortName+=item[:b]
            b+=-1 
        #print i.split(directory+'/')[1].split('.')[0], '\t',ClustNb
        file2=file.replace('>','>'+shortName+'_')
        Compfile.write(file2)
    Compfile.close()
    os.system('uclust --sort %s --output %s.sorted'%(directory+'/Comp/CompCons.fas',directory+'/Comp/CompCons.fas'))
    os.system('uclust --cluster %s.sorted --seedsout %s.uniq --uc %s.uc --id 0.7 --rev'%(directory+'/Comp/CompCons.fas',directory+'/Comp/CompCons.fas',directory+'/Comp/CompCons.fas'))

    
def launch(directory):
    for i in iglob(directory+'/*.seq'):
        if os.path.isfile(i+'N') : a=i+'N'
        else: a=i
        options.input=a
        if os.path.isdir(a+'M.dir/TRF') : 
            try: automitaur.launch(a,options.program)
            except:pass
        else: automitaur.goon(a,options.program)
        
def launchlist(list):
    genomes=open(list).readlines()
    for a in genomes:
        if os.path.isfile(a.rstrip()+'N') : b=a.rstrip()+'N'
        else:b=a.rstrip()
        options.input=b
        print b , options.program
        if os.path.isdir(b+'M.dir/TRF') : 
            try: automitaur.launch(b, options.program)
            except:pass
        else: 
            try: os.mkdir(b+'M.dir')
            except: pass
            automitaur.goon(b,options.program)
            
parser = OptionParser()
parser.add_option("-i", "--input", dest="input",help=" genome input file")
parser.add_option("-p", "--prog", dest="program",help=" program")
(options,args) = parser.parse_args()

if __name__ == '__main__':
    if 'BLAST' in sys.argv: options.program='BLAST'
    if len(sys.argv)==2: de(sys.argv[1]) #directory containing analysed genomes
    if len(sys.argv)>=3 and sys.argv[2] =='A': launch(sys.argv[1]) # directory containing genome to analysed
    if len(sys.argv)>=3 and sys.argv[2] =='L': launchlist(sys.argv[1])
