#!usr/bin/env python

#################  AutoMITAur.v1.0: A tool for de novo detection  of MITE ##################
#
# Main objective: de novo detection of MITE in sequenced genome
#
# Scientific contributors:  Aurelie Hua-Van
#
#
# Copyright 2013 Aurelie Hua-Van, ahuavan@legs.cnrs-gif.fr
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
## SCIENTISTS: please be aware that the fact that this program is released
## as Free Software does not excuse you from scientific propriety, which
## obligates you to give appropriate credit! If you write a scientific paper
## describing research that made substantive use of this program, it is your
## obligation as a scientist to (a) mention the fashion in which this software
## was used, including the version number, with a citation to the literature,
## in the Methods section, to allow replication; and/or (b) mention this
## software in the Acknowledgements section.
#
#############################################################################

import re,string,random,glob,shutil
import os, sys, MakeFasta,MakeSeqN
from Bio import SeqIO
from Bio import AlignIO
from Bio.Seq import Seq
from Bio.SeqRecord import SeqRecord
from Bio.Align import AlignInfo
from Bio.Align import MultipleSeqAlignment
from Bio.Alphabet import IUPAC
from StringIO import StringIO

global seq3


matrice=[]

def ask(*arg):
	"""
	Add a consensus sequence to an existing aligment, (batch files accepted)
	"""
	if arg:
	    infine=arg[0]
	    print '>>> Consensus of ',infine
	else:
	    #in2=raw_input("Sont-ce des fichiers fasta ? [y]/n: ")
	    infine=raw_input("Files names ? [*]").rstrip()
	    print infine
	try :
	    arg[1]
	    print arg[1] , 'consensus alignment'
	    question=arg[1]
	except:
		question=raw_input('Align consensuses (if several alignments) ? y\[n]')

	dir=os.path.dirname(infine)
	print dir
	################# If list of alignments ################################
	if '*' in infine:
	    consensus=open(infine.split('*')[0]+'ConsTot'+infine.split('*')[1],'w')	
	    print 'Recursing over', infine 
	    for x in glob.glob(infine):
	    	print x
	    	if '.cons' in x or 'ConsTot' in x :pass
	    	else:
	    		conseq=GenerateConsensus(x)
	    		if consensus: consensus.write('>'+os.path.basename(x).split('.')[0]+'cons\n'+str(conseq.seq).replace('-','')+'\n')
	    consensus.close()
	    ############### Consensus alignment #################################
	    if question=='y' or question=='Y' :
	    		os.system('muscle -in '+infine.split('*')[0]+'ConsTot'+infine.split('*')[1]+' -out '+infine.split('*')[0]+'ConsTot'+infine.split('*')[1]+'.afa') 
	    else: pass	
	    
	################# If one alignment ################################
	else: GenerateConsensus(infine)

def GenerateConsensus(x):
   # put sequences in lower case	   
	alignment = AlignIO.read(x, "fasta") 
	alilower=[]
	for seq in alignment:
		seqlower=seq.seq.lower()
		alilower.append(SeqRecord(seqlower, id=seq.id,description=''))
	AlignIO.write(MultipleSeqAlignment(alilower),x, 'fasta')
	
#########################    counter 0    ###########################
	seqs='' 	   
	alignment = AlignIO.read(x, "fasta")
	newlist=[]
	alignmentN=[]

	for seq in alignment:
		# suppress existing consensus
		if "cons" in seq.id or 'consensus' in seq.id: pass
		else: seqs+='>'+seq.id+'\n'+str(seq.seq)+'\n' # add fasta seq in string format
		# transformation of external '-' into '?'
		seqn=MakeSeqN.seqN(str(seq.seq))
		# list of modified seauences
		alignmentN.append(SeqRecord(Seq(seqn), id=seq.id,description=''))
		newlist.append(seq)
		
	#### Create consensus	   
	cons=''
	constrict=""
	dico={'a':1,'t':2,'w':3,'g':4,'r':5,'k':6,'d':7,'c':8,'m':9,'y':10,'h':11, 's':12,'v':13,'b':13, 'n':15,'-':16}		   
	revDico = dict(zip(dico.values(), dico.keys()))
	listnb=[(0,'-'),(1,'a'),(2,'c'),(3,'g'),(4,'t')]
	
   ####################################################################		  
   #################	   For each position      	     ##############
   ####################################################################	

	for nt in range(MultipleSeqAlignment(alignmentN).get_alignment_length()):
	    column=alignment[:,nt]
	    m=[column.count('-'),column.count('a'),column.count('c'),column.count('g'),column.count('t')]
	    n=[column.count('-'),column.count('a'),column.count('c'),column.count('g'),column.count('t')]
	    o=[column.count('-'),column.count('a'),column.count('c'),column.count('g'),column.count('t')]
	    

	    # on remplace le max par 0 (0 en position max(m)+1
	    n[m.index(max(m))]=-1
	    o[m.index(max(m))]=-1
	    o[n.index(max(n))]=-1
		#print 'm',m,max(m),max(n),max(o),(m[0]+m[1]+m[2]+m[3])/2.,
		
	    if max(m)==max(n) and max(n)>max(o): # equality for 2 nt take --> the second one
	    	cons      +='n'
	    	constrict+=listnb[max(m.index(max(m)),n.index(max(n)))][1]
	    elif max(m)==max(n) and max(n)==max(o): # equality for 3 nt take --> the third one
	    	cons     +='n'
	    	constrict+=listnb[min(n.index(max(n)),o.index(max(o)))][1]
	    elif max(m)<=len(alignment)/2. and m.index(max(m))==0: # if relative majority of '-', --> take the second most frequent
	    	cons     +=listnb[m.index(max(n))][1] 
	    	constrict+=listnb[m.index(max(n))][1] 
	    else:
	    	cons     +=listnb[m.index(max(m))][1] 
	    	constrict+=listnb[m.index(max(m))][1] 

	newlist.insert(0, SeqRecord(Seq(constrict), id=os.path.basename(x).split('.')[0],description=''))
	fileout=x+'.cons'
	fileout = StringIO()
	
	constrictclean=constrict.replace('-','')
	return SeqRecord(Seq(constrictclean), id=os.path.basename(x).split('.')[0],description='')
	


def clean(dir, prog, consfile):
    
	ClustBil=open(consfile+'.uc.bilan').readlines()
	FileExt=['.allafa','.afa','.ifl.afa','.fl53']
	Bilan=open(dir+'/'+prog+'/BilanNbSeq','w')
	shutil.copy(consfile,dir+'/'+prog+'/Cons/')# copy cons file clean
	for line in ClustBil: # for each new cluster
	    if line[0]=='#':pass
	    else: 
	        for ext in FileExt:
	            for cluster in line.split('\t')[1:]: # for each cluster in the line
	                Clust = os.path.dirname(consfile)+'/'+cluster.rstrip()[:-1]+ext
	                if cluster.rstrip()[-1]=='*':
	                    ListSeq=list(SeqIO.parse(Clust,'fasta'))
	                    main=cluster.rstrip()[:-1]
	                if cluster.rstrip()[-1]=='-':
	                    ListSeq.extend([rec.reverse_complement(id=rec.id,description='') for rec in SeqIO.parse(Clust,'fasta')])
	                if cluster.rstrip()[-1]=='+': 
	                    ListSeq.extend([rec for rec in SeqIO.parse(Clust,'fasta')])   
	            if ext=='.allafa':nbtot=(len(ListSeq))
	            if ext=='.afa': nbind=(len(ListSeq))
	            SeqIO.write(ListSeq,dir+'/'+prog+'/Cons/'+main+ext,'fasta')
	            ListSeq=[]
	        Bilan.write(main+'\t'+str(nbtot)+'\t'+str(nbind)+'\n')
	Bilan.close()

	# clean TIR file
	TIRlist=[rec.id for rec in SeqIO.parse(dir+'/'+prog+'/Clusters/Clust.Cons.fas.uniq'	,'fasta')]   
	oldTIRdict=SeqIO.to_dict(SeqIO.parse(dir+'/'+prog+'/BilanTIR.fa','fasta'))
	newTIRlist=[oldTIRdict[seq] for seq in TIRlist]
	SeqIO.write(newTIRlist,dir+'/'+prog+'/BilanTIR.fa','fasta')    
	os.rename(consfile+'.uniq',dir+'/'+prog+'/Cons/Clust.Cons.fas')


if __name__ == '__main__' : 
    if len(sys.argv)==2:GenerateConsensus(sys.argv[1])
    
    else: ask()

