#!usr/bin/env python

#################  AutoMITAur.v1.0: A tool for de novo detection  of MITE ##################
#
# Main objective: de novo detection of MITE in sequenced genome
#
# Scientific contributors:  Aurelie Hua-Van
#
#
# Copyright 2013 Aurelie Hua-Van, ahuavan@legs.cnrs-gif.fr
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
## SCIENTISTS: please be aware that the fact that this program is released
## as Free Software does not excuse you from scientific propriety, which
## obligates you to give appropriate credit! If you write a scientific paper
## describing research that made substantive use of this program, it is your
## obligation as a scientist to (a) mention the fashion in which this software
## was used, including the version number, with a citation to the literature,
## in the Methods section, to allow replication; and/or (b) mention this
## software in the Acknowledgements section.
#
#############################################################################

import re, os, sys


def ask():
	"""
	fait un vrai fasta a partir d'un fichier mal foutu, phylip, gb ou Se-Al. 
	!!! le fichier doit tout de meme etre en linebreaks Unix
	"""
	nom=raw_input('MakeFasta >> Quel fichier ? :').replace(' ','')
	out=fasta(nom)

#Align
def fastAL(nom):
	"""
	fait un vrai fasta a partir d'un fasta mal foutu. 
	!!! le fichier doit tout de meme etre en linebreaks Unix
	"""   
# ouverture du fichier
	seq=open(nom).read()
# determination du format 
	if 'Database' in seq: out= seal(nom) # si SeAl
	elif 'LOCUS' in  seq: out= gb(nom) #si GenBank
	elif '>'in seq: out=fas(nom)# si Fasta

	seql=open('%s'%nom).read().split('\n')
	seqw=open('%s'%nom,'w')
	
	l=[len(a) for a in seql] # Longeur de chaque ligne
	maxi=max(l)
	for i in seql:
		if '>' in i:seqw.write(i+'\n')
		else:
			itemp=i
			while len(itemp)<maxi: itemp+='-'
			seqw.write(itemp+'\n')

def fasta(nom):
	"""
	fait un vrai fasta a partir d'un fasta mal foutu. 
	!!! le fichier doit tout de meme etre en linebreaks Unix
	"""   
# ouverture du fichier
	seq=open('%s'%nom).read()
# determination du format 
	if 'Database' in seq: out= seal(nom) # si SeAl
	elif 'LOCUS' in  seq: out= gb(nom) #si GenBank
	elif '>'in seq: #si Fasta
		if seq.count('>')==2*seq.count('\n'):pass
		else:out=fas(nom)# 
	elif seq.replace(' ','').replace('\n','')[0] in "123456789": out=phylip(nom)
	return out

def write(nom,file):
	#print "MakeFasta is making fasta format of file %s"%nom
	ouvrir=open('%s'%nom,'w')
	seqfasta=''
	r=0
	for x in file: # pour chaque sequence x
		seq=x.split('\n') #on la tronconne en bloc
		seqfasta='>'+seq[0]+'\n'+''.join(seq[1:])
		if r==0 :	pass
		else: 		ouvrir.write('\n')
		ouvrir.write('>'+seq[0]+'\n'+''.join(seq[1:]))
		r=r+1
	#print r
	ouvrir.close()
	return nom
########################################
######### FORMAT
#####################################
def fas(nom):
	file1=open('%s'%nom).read()
	file1=(file1).replace('\r','\n')
	file1=(file1).replace(' ','')
	file1=(file1).replace('\t','_')
	file=file1.split('>')[1:]# seq par seq
	out=write(nom,file)    
	return out



def seal(nom):
	"""
	fait un vrai fasta a partir d'un fichier seal. 
	!!! le fichier doit tout de meme etre en linebreaks Unix
	"""   
	print 'This is a Se-Al file'
	file=open('%s'%nom).read()
	op2=file.split("\t\t\tID='MCoL';")[0]
	ex1=re.compile('\t\t\t\t\tName="(.+)"')
	ex2=re.compile('Sequence="(.+)"')
	l1=ex1.findall(op2)
	l2=ex2.findall(op2)
	format=''
	for i,x in enumerate(l1):
	    format+='>'+x+'\n'+l2[i]+'\n'
	file=format.split('>')[1:] #liste sequence
	print len(file)
	out=write(nom,file)
	return out
	
def phylip(nom):
	"""
	fait un vrai fasta a partir d'un fichier phylip. 
	"""   
	print "MakeFasta is making fasta format of file %s"%nom
	filelines=open('%s'%nom).readlines()
	ouvrir=open(nom+'.fasta','w')
	
	ex1=''
	seq=''
	for l in filelines:
	    if re.match("\S", l): 
	        print "found sequence"
	        ex1=l.split('  ')[0][:10]	        
	        seq=('').join(l[10:].split(' ')[1:])
	        ouvrir.write('>'+ex1+'\n'+seq)
	        print ex1, seq
	    else : pass
	ouvrir.close()
	
def gb(nom):
	"""
	fait un vrai fasta a partir d'un fichier gb. 
	"""   
	op=open('%s'%nom)
	op1=op.read()
	op2=op1.split("\n//\n")
	print len(op2)
	l1=[]
	l2=[]
	print "MakeFasta is making fasta format of file %s"%nom
	ouvrir=open(nom+'.fasta','w')
	
	for loc in op2[:-1]:
	    seq=''
	    ex1=loc.split('  GI:')[1].split('\n')[0]
	    ex2=loc.split('\nORIGIN      ')[1]
	    for item in ex2.split('\n'):
	        seq=seq+item[10:]
	    seq=seq.replace(' ','')
	    ouvrir.write('>'+ex1+'\n'+seq+'\n')
	ouvrir.close()

if __name__ == '__main__' : 

    if len(sys.argv)==2:fasta(sys.argv[1])
    elif len(sys.argv)==3:fastAL(sys.argv[1])
    else: ask()
else: 
    pass