#!usr/bin/env python

#################  AutoMITAur.v1.0: A tool for de novo detection  of MITE ##################
#
# Main objective: de novo detection of MITE in sequenced genome
#
# Scientific contributors:  Aurelie Hua-Van
#
#
# Copyright 2013 Aurelie Hua-Van, ahuavan@legs.cnrs-gif.fr
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
## SCIENTISTS: please be aware that the fact that this program is released
## as Free Software does not excuse you from scientific propriety, which
## obligates you to give appropriate credit! If you write a scientific paper
## describing research that made substantive use of this program, it is your
## obligation as a scientist to (a) mention the fashion in which this software
## was used, including the version number, with a citation to the literature,
## in the Methods section, to allow replication; and/or (b) mention this
## software in the Acknowledgements section.
#
#############################################################################


import os, sys, re

def seqN(string):
	seqN=string.replace('A','N').replace('T','N').replace('C','N').replace('G','N')
	seqN=string.replace('a','n').replace('t','n').replace('c','n').replace('g','n')
	seqn=''
	for i,nt in enumerate(string):
		if nt=='-' and ('N' not in seqN[0:i] and 'n' not in seqN[0:i]):seqn+='?' # - en 5' --> ?
		elif nt=='-' and ('N' not in seqN[i+1:-1] and 'n' not in seqN[i+1:-1]):seqn+='?' # - en 3' --> ?
		else: seqn+=nt
	return seqn