#!usr/bin/env python

#################  AutoMITAur.v1.0: A tool for de novo detection  of MITE ##################
#
# Main objective: de novo detection of MITE in sequenced genome
#
# Scientific contributors:  Aurelie Hua-Van
#
#
# Copyright 2013 Aurelie Hua-Van, ahuavan@legs.cnrs-gif.fr
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
## SCIENTISTS: please be aware that the fact that this program is released
## as Free Software does not excuse you from scientific propriety, which
## obligates you to give appropriate credit! If you write a scientific paper
## describing research that made substantive use of this program, it is your
## obligation as a scientist to (a) mention the fashion in which this software
## was used, including the version number, with a citation to the literature,
## in the Methods section, to allow replication; and/or (b) mention this
## software in the Acknowledgements section.
#
#############################################################################
import re, sys, shutil, os, subprocess, shlex, time,glob

# trf need to be installed

def MaskAur(input,Mdirsuffix,prog):
	t0=time.time()
	print ">>> masking file using trf"
	print input, Mdirsuffix, prog
	try: os.mkdir(input+Mdirsuffix+os.sep+'TRF') 
	except:pass #logging.exception('TRF directory already exist')#pass
	trfparam=' 2 7 7 80 10 50 500'
	trfparam2=trfparam.replace(' ','.')
	command_line='trf '+input  + trfparam +' -m -d '
	print
	print command_line
	trf = subprocess.call(shlex.split(command_line))
	
	os.rename(os.path.basename(input)+trfparam2+'.mask', input+'M')
	for file in glob.glob(os.path.basename(input)+'*'+trfparam2+'*'): 
	    os.rename(file, input+Mdirsuffix+ os.sep+'TRF/'+file)
	    
	
	t1=time.time()
	with open(input + Mdirsuffix + os.sep +prog+'/statistic', 'a') as statistics:
	     statistics.write('\nTRF masking :\t'+str(t1-t0)+' sec\n')
