#!usr/bin/env python

#################  AutoMITAur.v1.0: A tool for de novo detection  of MITE ##################
#
# Main objective: de novo detection of MITE in sequenced genome
#
# Scientific contributors:  Aurelie Hua-Van
#
#
# Copyright 2013 Aurelie Hua-Van, ahuavan@legs.cnrs-gif.fr
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
## SCIENTISTS: please be aware that the fact that this program is released
## as Free Software does not excuse you from scientific propriety, which
## obligates you to give appropriate credit! If you write a scientific paper
## describing research that made substantive use of this program, it is your
## obligation as a scientist to (a) mention the fashion in which this software
## was used, including the version number, with a citation to the literature,
## in the Methods section, to allow replication; and/or (b) mention this
## software in the Acknowledgements section.
#
#############################################################################

import re, os, sys, subprocess,shlex,shutil
from glob import iglob
from optparse import OptionParser
from Bio import SeqIO
import  MakeFasta
from FindBoundaries import Squeeze




def rmdup(clust): # F*F.allafa (aligned file with all seauences + flanking) --> ifl.afa (independant sequence only)
    clustbasename=os.path.splitext(clust)[0]
    # fasta file with duplicate to exclude
    dup=((os.sep).join(clustbasename.split('/')[:-2])+'/'+clustbasename.split('/')[-3]+'.allf.pba.seq.dup')
    listseq=[]
    seqs = SeqIO.to_dict(SeqIO.parse(clust, "fasta"))
    iflfile = clustbasename+'.ifl.afa'
    for seq in seqs.keys():
        if seq in open(dup).read().split('\n'): pass # exclude duplicated sequences
        else: listseq.append(seqs[seq])
    with open(os.path.dirname(clustbasename)+'BilanNbSeq','a') as BilanClust :
        BilanClust.write(os.path.basename(clustbasename)+'\t'+ str(len(seqs))+'\t'+ str(len(listseq))+'\n')

    if len(listseq)>1: # TODO :according to the minseq value
        SeqIO.write(listseq,iflfile,'fasta')
        MakeFasta.fastAL(iflfile)
        #command_line='seqmagick mogrify  --squeeze %s'%iflfile #'.ifl.afa'
        #subprocess.call(shlex.split(command_line))
        Squeeze(iflfile)
        os.remove(clustbasename+'.seq')

        return 1    
        
    else:
        for allfile in iglob(clustbasename+'*'):
            newlocfile=os.path.dirname(allfile)+'Exclu1/'+os.path.basename(allfile)
            os.rename(allfile,newlocfile)
        return 0

def batch(files):
    for file in iglob(files): rmdup(file)
    
if __name__ == '__main__':
   if len(sys.argv)==2 and '*' in sys.argv[1]: batch(sys.argv[1])
   else : remove_duplicate(sys.argv[1])